commit 95eb12afe18d4fe2a47f548238da5fc730a8c0de
Author: freddy77 <freddy77>
Date:   Tue Sep 1 05:47:31 2009 +0000

    add and fix test for numeric in dblib

diff --git a/ChangeLog b/ChangeLog
index 5d1ab3a..a87a933 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Tue Sep  1 07:47:25 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/rpc.c src/dblib/unittests/.cvsignore:
+	* src/dblib/unittests/Makefile.am src/dblib/unittests/common.c:
+	* src/dblib/unittests/common.h src/dblib/unittests/numeric.c:
+	* src/dblib/unittests/numeric.sql:
+	- add and fix test for numeric in dblib
+
 Thu Aug 27 15:36:42 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/cancel.c:
 	- override odbcinst.ini in cancel test to avoid hang using unixODBC
@@ -1820,4 +1827,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2864 2009/08/27 13:37:40 freddy77 Exp $
+$Id: ChangeLog,v 1.2865 2009/09/01 05:47:31 freddy77 Exp $
diff --git a/src/dblib/rpc.c b/src/dblib/rpc.c
index a335112..fa1d1b6 100644
--- a/src/dblib/rpc.c
+++ b/src/dblib/rpc.c
@@ -54,7 +54,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: rpc.c,v 1.69 2009/05/28 16:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: rpc.c,v 1.70 2009/09/01 05:47:31 freddy77 Exp $");
 
 static void rpc_clear(DBREMOTE_PROC * rpc);
 static void param_clear(DBREMOTE_PROC_PARAM * pparam);
@@ -335,6 +335,8 @@ param_row_alloc(TDSPARAMINFO * params, TDSCOLUMN * curcol, int param_num, void *
 	if (size > 0 && value) {
 		tdsdump_log(TDS_DBG_FUNC, "copying %d bytes of data to parameter #%d\n", size, param_num);
 		if (!is_blob_col(curcol)) {
+			if (is_numeric_type(curcol->column_type))
+				memset(curcol->column_data, 0, sizeof(TDS_NUMERIC));
 			memcpy(curcol->column_data, value, size);
 		} else {
 			TDSBLOB *blob = (TDSBLOB *) curcol->column_data;
@@ -398,6 +400,15 @@ param_info_alloc(TDSSOCKET * tds, DBREMOTE_PROC * rpc)
 
 		tdsdump_log(TDS_DBG_INFO1, "parm_info_alloc(): parameter null-ness = %d\n", param_is_null);
 
+		pcol = params->columns[i];
+
+		if (temp_value && is_numeric_type(temp_type)) {
+			DBDECIMAL *dec = (DBDECIMAL*) temp_value;
+			pcol->column_prec = dec->precision;
+			pcol->column_scale = dec->scale;
+			if (dec->precision > 0 && dec->precision <= MAXPRECISION)
+				temp_datalen = tds_numeric_bytes_per_prec[dec->precision] + 2;
+		}
 		if (param_is_null || (p->status & DBRPCRETURN)) {
 			if (param_is_null) {
 				temp_datalen = 0;
@@ -410,8 +421,6 @@ param_info_alloc(TDSSOCKET * tds, DBREMOTE_PROC * rpc)
 			temp_datalen = tds_get_size_by_type(temp_type);
 		}
 
-		pcol = params->columns[i];
-
 		/* meta data */
 		if (p->name) {
 			tds_strlcpy(pcol->column_name, p->name, sizeof(pcol->column_name));
diff --git a/src/dblib/unittests/.cvsignore b/src/dblib/unittests/.cvsignore
index 691f42b..2d8e014 100644
--- a/src/dblib/unittests/.cvsignore
+++ b/src/dblib/unittests/.cvsignore
@@ -45,4 +45,5 @@ hang
 null
 null2
 setnull
+numeric
 
diff --git a/src/dblib/unittests/Makefile.am b/src/dblib/unittests/Makefile.am
index 3fec4e6..df43a20 100644
--- a/src/dblib/unittests/Makefile.am
+++ b/src/dblib/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.48 2009/03/17 13:34:39 freddy77 Exp $
+# $Id: Makefile.am,v 1.49 2009/09/01 05:47:31 freddy77 Exp $
 TESTS		=	t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) t0005$(EXEEXT) t0006$(EXEEXT)\
 			t0007$(EXEEXT) t0008$(EXEEXT) t0009$(EXEEXT)\
@@ -10,13 +10,13 @@ TESTS		=	t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			bcp$(EXEEXT) thread$(EXEEXT) text_buffer$(EXEEXT)\
 			done_handling$(EXEEXT) timeout$(EXEEXT) \
 			hang$(EXEEXT) null$(EXEEXT) null2$(EXEEXT) \
-			setnull$(EXEEXT)
+			setnull$(EXEEXT) numeric$(EXEEXT)
 check_PROGRAMS	=	$(TESTS)
 
 SQL_DIST = 	bcp.sql dbmorecmds.sql done_handling.sql rpc.sql \
 		t0001.sql t0002.sql t0003.sql t0004.sql t0005.sql t0006.sql t0007.sql t0009.sql \
 		t0011.sql t0012.sql t0013.sql t0014.sql t0015.sql t0016.sql t0017.sql t0018.sql \
-		t0020.sql t0022.sql t0023.sql text_buffer.sql timeout.sql
+		t0020.sql t0022.sql t0023.sql text_buffer.sql timeout.sql numeric.sql
 
 noinst_SCRIPTS	= $(SQL_DIST)
 
@@ -53,6 +53,7 @@ hang_SOURCES	=	hang.c common.c common.h
 null_SOURCES	=	null.c common.c common.h
 null2_SOURCES	=	null2.c common.c common.h
 setnull_SOURCES	=	setnull.c common.c common.h
+numeric_SOURCES =	numeric.c common.c common.h
 
 AM_CPPFLAGS	= 	-DFREETDS_SRCDIR=\"$(srcdir)\" -I$(top_srcdir)/include
 if MINGW32
diff --git a/src/dblib/unittests/common.c b/src/dblib/unittests/common.c
index 016466e..0eedcab 100644
--- a/src/dblib/unittests/common.c
+++ b/src/dblib/unittests/common.c
@@ -14,7 +14,7 @@
 
 #include "replacements.h"
 
-static char software_version[] = "$Id: common.c,v 1.37 2009/08/26 12:19:01 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.38 2009/09/01 05:47:31 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 typedef struct _tag_memcheck_t
@@ -271,7 +271,12 @@ sql_cmd(DBPROCESS *dbproc)
 	char line[2048], *p = line;
 	int i = 0;
 	RETCODE erc=SUCCEED;
-	
+
+	if (!input_file) {
+		fprintf(stderr, "%s: error: SQL input file \"%s\" not opened\n", BASENAME, sql_file);
+		exit(1);
+	}
+
 	while ((p = fgets(line, (int)sizeof(line), input_file)) != NULL && strcasecmp("go\n", p) != 0) {
 		printf("\t%3d: %s", ++i, p);
 		if ((erc = dbcmd(dbproc, p)) != SUCCEED) {
@@ -288,6 +293,15 @@ sql_cmd(DBPROCESS *dbproc)
 	return erc;
 }
 
+RETCODE
+sql_rewind(void)
+{
+	if (!input_file)
+		return FAIL;
+	rewind(input_file);
+	return SUCCEED;
+}
+
 void
 check_crumbs(void)
 {
diff --git a/src/dblib/unittests/common.h b/src/dblib/unittests/common.h
index e167ce3..bfd7e5a 100644
--- a/src/dblib/unittests/common.h
+++ b/src/dblib/unittests/common.h
@@ -2,7 +2,7 @@
 #ifndef COMMON_h
 #define COMMON_h
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.19 2009/05/28 16:15:29 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.20 2009/09/01 05:47:31 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #if HAVE_CONFIG_H
@@ -92,6 +92,7 @@ int syb_msg_handler(DBPROCESS * dbproc,
 int syb_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr);
 
 RETCODE sql_cmd(DBPROCESS *dbproc);
+RETCODE sql_rewind(void);
 
 #define int2ptr(i) ((void*)(((char*)0)+(i)))
 #define ptr2int(p) ((int)(((char*)(p))-((char*)0)))
diff --git a/src/dblib/unittests/numeric.c b/src/dblib/unittests/numeric.c
new file mode 100644
index 0000000..d23c7db
--- /dev/null
+++ b/src/dblib/unittests/numeric.c
@@ -0,0 +1,161 @@
+#define MSDBLIB 1
+#include "common.h"
+
+static void
+dump_addr(FILE *out, const char *msg, const void *p, size_t len)
+{
+	size_t n;
+	if (msg)
+		fprintf(out, "%s", msg);
+	for (n = 0; n < len; ++n)
+		fprintf(out, " %02X", ((unsigned char*) p)[n]);
+	fprintf(out, "\n");
+}
+
+static void
+chk(RETCODE ret, const char *msg)
+{
+	printf("res %d\n", ret);
+	if (ret == SUCCEED)
+		return;
+	fprintf(stderr, "error: %s\n", msg);
+	exit(1);
+}
+
+static void
+test(int bind_type)
+{
+	LOGINREC *login;
+	DBPROCESS *dbproc;
+	DBNUMERIC *num = NULL, *num2 = NULL;
+	RETCODE ret;
+	int i;
+
+	sql_rewind();
+	login = dblogin();
+
+	DBSETLUSER(login, USER);
+	DBSETLPWD(login, PASSWORD);
+	DBSETLAPP(login, "numeric");
+	dbsetmaxprocs(25);
+	DBSETLHOST(login, SERVER);
+
+	dbproc = dbopen(login, SERVER);
+	dbloginfree(login);
+	login = NULL;
+	if (strlen(DATABASE))
+		dbuse(dbproc, DATABASE);
+
+	sql_cmd(dbproc);
+	dbsqlexec(dbproc);
+	while (dbresults(dbproc) != NO_MORE_RESULTS) {
+		/* nop */
+	}
+
+	sql_cmd(dbproc);
+	dbsqlexec(dbproc);
+	while (dbresults(dbproc) != NO_MORE_RESULTS) {
+		/* nop */
+	}
+
+	ret = dbcmd(dbproc,
+		    "SET ARITHABORT ON;"
+		    "SET CONCAT_NULL_YIELDS_NULL ON;"
+		    "SET ANSI_NULLS ON;"
+		    "SET ANSI_NULL_DFLT_ON ON;"
+		    "SET ANSI_PADDING ON;"
+		    "SET ANSI_WARNINGS ON;"
+		    "SET ANSI_NULL_DFLT_ON ON;"
+		    "SET CURSOR_CLOSE_ON_COMMIT ON;"
+		    "SET QUOTED_IDENTIFIER ON");
+	chk(ret, "dbcmd");
+	ret = dbsqlexec(dbproc);
+	chk(ret, "dbsqlexec");
+
+	ret = dbcancel(dbproc);
+	chk(ret, "dbcancel");
+
+	ret = dbrpcinit(dbproc, "testDecimal", 0);
+	chk(ret, "dbrpcinit");
+
+	num = (DBDECIMAL *) calloc(1, sizeof(DBDECIMAL));
+	num->scale = 5;
+	num->precision = 16;
+	dbconvert(dbproc, SYBVARCHAR, (const BYTE *) "123.45", -1, SYBDECIMAL, (BYTE *) num, sizeof(*num));
+
+	ret = dbrpcparam(dbproc, "@idecimal", 0, SYBDECIMAL, -1, sizeof(DBDECIMAL), (BYTE *) num);
+	chk(ret, "dbrpcparam");
+	ret = dbrpcsend(dbproc);
+	chk(ret, "dbrpcsend");
+	ret = dbsqlok(dbproc);
+	chk(ret, "dbsqlok");
+
+	/* TODO check MS/Sybase format */
+	num2 = (DBDECIMAL *) calloc(1, sizeof(DBDECIMAL));
+	num2->precision = 20;
+	num2->scale = 10;
+	dbconvert(dbproc, SYBVARCHAR, (const BYTE *) "246.9", -1, SYBDECIMAL, (BYTE *) num2, sizeof(*num2));
+
+	for (i=0; (ret = dbresults(dbproc)) != NO_MORE_RESULTS; ++i) {
+		RETCODE row_code;
+
+		switch (ret) {
+		case SUCCEED:
+			if (DBROWS(dbproc) == FAIL)
+				continue;
+			assert(DBROWS(dbproc) == SUCCEED);
+			printf("dbrows() returned SUCCEED, processing rows\n");
+
+			memset(num, 0, sizeof(*num));
+			num->precision = num2->precision;
+			num->scale = num2->scale;
+			dbbind(dbproc, 1, bind_type, 0, (BYTE *) num);
+
+			while ((row_code = dbnextrow(dbproc)) != NO_MORE_ROWS) {
+				if (row_code == REG_ROW) {
+					if (memcmp(num, num2, sizeof(*num)) != 0) {
+						fprintf(stderr, "Failed. Output results does not match\n");
+						dump_addr(stderr, "numeric: ", num, sizeof(*num));
+						dump_addr(stderr, "numeric2:", num2, sizeof(*num2));
+						exit(1);
+					}
+				} else {
+					/* not supporting computed rows in this unit test */
+					fprintf(stderr, "Failed.  Expected a row\n");
+					exit(1);
+				}
+			}
+			break;
+		case FAIL:
+			fprintf(stderr, "dbresults returned FAIL\n");
+			exit(1);
+		default:
+			fprintf(stderr, "unexpected return code %d from dbresults\n", ret);
+			exit(1);
+		}
+	} /* while dbresults */
+
+	sql_cmd(dbproc);
+
+	free(num2);
+	free(num);
+
+	dbclose(dbproc);
+}
+
+int
+main(int argc, char **argv)
+{
+	read_login_info(argc, argv);
+
+	dbinit();
+
+	test(DECIMALBIND);
+	test(NUMERICBIND);
+
+	dbexit();
+
+	printf("Succeed\n");
+	return 0;
+}
+
diff --git a/src/dblib/unittests/numeric.sql b/src/dblib/unittests/numeric.sql
new file mode 100644
index 0000000..c52b220
--- /dev/null
+++ b/src/dblib/unittests/numeric.sql
@@ -0,0 +1,12 @@
+IF OBJECT_ID('testDecimal') IS NOT NULL DROP PROC testDecimal
+go
+CREATE PROCEDURE testDecimal
+  @idecimal NUMERIC(20,10)
+AS
+BEGIN
+	SELECT @idecimal*2
+END
+go
+IF OBJECT_ID('testDecimal') IS NOT NULL DROP PROC testDecimal
+go
+

